/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 03/07/22.
//

#ifndef DEMO_TOPDOWN_HPP
#define DEMO_TOPDOWN_HPP

#include "fggl/scenes/game.hpp"

namespace demo {

	class TopDown : public fggl::scenes::Game {

		public:
			explicit TopDown(fggl::App& app);
			void activate() override;

			void update(float dt) override;
			void render(fggl::gfx::Graphics& gfx) override;

		private:
			constexpr static fggl::math::vec3 HINT_COLOUR{0.5f, 0.0f, 0.0f};
			fggl::math::vec3 cameraOffset = {-15.0F, 15.0F, 0.0F};

			void pick_object();

	};

}

#endif //DEMO_TOPDOWN_HPP
