//
// Created by webpigeon on 23/10/2021.
//

#include <gtest/gtest.h>
#include <gmock/gmock.h>

#include <fggl/ecs3/utils.hpp>

namespace {

    TEST(ecs3, searchEmpty) {
        int arr[0];
        const std::size_t size = 0;

        auto result = fggl::utils::search(arr, size, 0);
        ASSERT_EQ(size, result);
    }

    TEST(ecs3, searchSingle) {
        int arr[] = {7};
        const std::size_t size = 1;

        auto result = fggl::utils::search(arr, size, 7);
        ASSERT_EQ(0, result);
    }

    TEST(ecs3, searchNoExist) {
        int arr[] = {2,4,6,8,10};
        const std::size_t size = 5;

        auto result = fggl::utils::search(arr, size, 7);
        ASSERT_EQ(size, result);
    }

    TEST(ecs3, searchFirst) {
        int arr[] = {2,4,6,8,10};
        const std::size_t size = 5;

        auto result = fggl::utils::search(arr, size, 2);
        ASSERT_EQ(0, result);
    }

    TEST(ecs3, searchLast) {
        int arr[] = {2,4,6,8,10};
        const std::size_t size = 5;

        auto result = fggl::utils::search(arr, size, 6);
        ASSERT_EQ(2, result);
    }

}